#include <stdio.h>

#include "SDL.h"

#define USE_FLT

#include "tri_rend.h"



SDL_Surface* alloc_imit_surf( SDL_Surface *old )
{
	return
	(
		SDL_CreateRGBSurface
		(
			old->flags,
			
			old->w, old->h,
			
			old->format->BitsPerPixel,
			
			0 /* old->format->Rmask */,
			0 /* old->format->Gmask */,
			0 /* old->format->Bmask */,
			0 /* old->format->Amask */
		)
	);
}



int main( int argn, char *argc[] )
{
	tri_info data;
	TRI dest_t, src_t;
	SDL_Surface *src_i, *dest_i;
	SDL_Rect r;
	long i1, i2;
	float constr_test[ 3 ] = { 0.2, 5, 1 };
	
	
	
	printf( "\n" );
	
	
	
	INT_CONSTR ( 3, constr_test,    &i1, &i2 );
	printf
	(
		"INT_CONSTR() test 1: %f, %f, %f :: %i, %i;\n",
		constr_test[ 0 ], constr_test[ 1 ], constr_test[ 2 ],
		(int)i1, (int)i2
	);
	
	constr_test[ 0 ] = 5; constr_test[ 1 ] = -3; constr_test[ 2 ] = 0;
	INT_CONSTR ( 3, constr_test,    &i1, &i2 );
	printf
	(
		"INT_CONSTR() test 2: %f, %f, %f :: %i, %i;\n",
		constr_test[ 0 ], constr_test[ 1 ], constr_test[ 2 ],
		(int)i1, (int)i2
	);
	
	
	
	printf( "Textured trangle test starting.\n" );
	
	
	
		/* Init. */
	if( SDL_Init( 0 ) < 0 )
	{
		printf( "SDL_Init failed: %s\n", SDL_GetError() );
	}
	
	
	data.src_tri = &src_t;
	data.dest_tri = &dest_t;
	
	
	src_i = SDL_LoadBMP( "Base1.bmp" );
	if( !src_i )
	{
		printf( "Failed to load Base1.bmp: %s\n", SDL_GetError() );
	}
	if( !( src_i->pixels ) )
	{
		printf( "Source image has no pixels.\n" );
	}
	
	data.src = src_i;
	
	
	data.src_fill = SDL_MapRGBA
						(
							src_i->format,
							
							0,   /* R */
							128, /* G */
							0,   /* B */
							128  /* A */
						);
	
	
	/* Place the destination triangle. */
	
		/* I've been asked to make this multi-line instead of squishing everything together. */
	dest_t.x[ 0 ] = 190; dest_t.x[ 1 ] = 190; dest_t.x[ 2 ] = 63;
		dest_t.y[ 0 ] = 63; dest_t.y[ 1 ] = 190; dest_t.y[ 2 ] = 190;
	/*
	dest_t.x[ 0 ] = dest_i->w * 0.75; dest_t.x[ 1 ] = dest_i->w * 0.75; dest_t.x[ 2 ] = dest_i->w * 0.25;
		dest_t.y[ 0 ] = dest_i->h * 0.25; dest_t.y[ 1 ] = dest_i->h * 0.75; dest_t.y[ 2 ] = dest_i->h * 0.75;
	*/
	
	
	
	/* Place the source triangle. */
	
	src_t.x[ 0 ] = 0; src_t.x[ 1 ] = 0; src_t.x[ 2 ] = 255;
		src_t.y[ 0 ] = 0; src_t.y[ 1 ] = 255; src_t.y[ 2 ] = 255;
	
	
	dest_i = alloc_imit_surf( src_i );
	if( !dest_i )
	{
		printf( "Failed to allocate destination surface 1: %s\n", SDL_GetError() );
	}
	data.dest = dest_i;
	
	
	printf( "TRI_REND() result 1: %i;\n", (int)( TRI_REND( &data, &dest_t, &src_t ) ) );
	
	
	if( SDL_SaveBMP( dest_i, "Result1.bmp" ) < 0 )
	{
		printf( "Failed to save destination surface 1: %s\n", SDL_GetError() );
	}
	
	SDL_FreeSurface( dest_i );
	dest_i = (SDL_Surface*)0;
	
	
	
	src_t.x[ 0 ] = src_i->w * 0.25; src_t.x[ 1 ] = src_i->w * 0.25; src_t.x[ 2 ] = src_i->w * 0.75;
		src_t.y[ 0 ] = src_i->h * 0.25; src_t.y[ 1 ] = src_i->h * 0.75; src_t.y[ 2 ] = src_i->h * 0.75;
	
	
	dest_i = alloc_imit_surf( src_i );
	if( !dest_i )
	{
		printf( "Failed to allocate destination surface 2: %s\n", SDL_GetError() );
	}
	data.dest = dest_i;
	
	
	if( !( src_i->pixels ) )
	{
		printf( "Source image has lost pixels.\n" );
	}
	printf( "TRI_REND() result 2: %i;\n", (int)( TRI_REND( &data, &dest_t, &src_t ) ) );
	
	
	if( SDL_SaveBMP( dest_i, "Result2.bmp" ) < 0 )
	{
		printf( "Failed to save destination surface 2: %s\n", SDL_GetError() );
	}
	
	SDL_FreeSurface( dest_i );
	dest_i = (SDL_Surface*)0;
	
	
	
	src_t.x[ 0 ] = 5; src_t.x[ 1 ] = 25; src_t.x[ 2 ] = 75;
		src_t.y[ 0 ] = 5; src_t.y[ 1 ] = 75; src_t.y[ 2 ] = 75;
	
	
	dest_i = alloc_imit_surf( src_i );
	if( !dest_i )
	{
		printf( "Failed to allocate destination surface 3: %s\n", SDL_GetError() );
	}
	data.dest = dest_i;
	
	
	printf( "TRI_REND() result 3: %i;\n", (int)( TRI_REND( &data, &dest_t, &src_t ) ) );
	
	
	if( SDL_SaveBMP( dest_i, "Result3.bmp" ) < 0 )
	{
		printf( "Failed to save destination surface 3: %s\n", SDL_GetError() );
	}
	
	SDL_FreeSurface( dest_i );
	dest_i = (SDL_Surface*)0;
	
	
	
	r.x = 32; r.y = 32; r.w = 128; r.h = 128;
	
	
	dest_i = alloc_imit_surf( src_i );
	if( !dest_i )
	{
		printf( "Failed to allocate destination surface 4: %s\n", SDL_GetError() );
	}
	data.dest = dest_i;
	
	
	if( SDL_FillRect( dest_i, &r, SDL_MapRGBA( src_i->format, 128,   /* R */ 0, /* G */ 128,   /* B */ 128  /* A */ ) ) < 0 )
	{
		printf( "FillRect failed on surface 4: %s\n", SDL_GetError() );
	}
	
	
	if( SDL_SaveBMP( dest_i, "Result4.bmp" ) < 0 )
	{
		printf( "Failed to save destination surface 4: %s\n", SDL_GetError() );
	}
	
	SDL_FreeSurface( dest_i );
	dest_i = (SDL_Surface*)0;
	
	
	
	r.x = 32; r.y = 32; r.w = 128; r.h = 128;
	
	src_t.x[ 0 ] = -5; src_t.x[ 1 ] = -25; src_t.x[ 2 ] = 75;
		src_t.y[ 0 ] = 5; src_t.y[ 1 ] = 75; src_t.y[ 2 ] = -75;
	
	
	dest_i = alloc_imit_surf( src_i );
	if( !dest_i )
	{
		printf( "Failed to allocate destination surface 5: %s\n", SDL_GetError() );
	}
	data.dest = dest_i;
	
	
	if( SDL_FillRect( dest_i, &r, SDL_MapRGBA( src_i->format, 128,   /* R */ 0, /* G */ 128,   /* B */ 128  /* A */ ) ) < 0 )
	{
		printf( "FillRect failed on surface 5: %s\n", SDL_GetError() );
	}
	
	printf( "TRI_REND() result 5: %i;\n", (int)( TRI_REND( &data, &dest_t, &src_t ) ) );
	
	
	if( SDL_SaveBMP( dest_i, "Result5.bmp" ) < 0 )
	{
		printf( "Failed to save destination surface 5: %s\n", SDL_GetError() );
	}
	
	SDL_FreeSurface( dest_i );
	dest_i = (SDL_Surface*)0;
	
	
	
	
	r.x = 32; r.y = 32; r.w = 128; r.h = 128;
	
	src_t.x[ 0 ] = -5; src_t.x[ 1 ] = -25; src_t.x[ 2 ] = 75;
		src_t.y[ 0 ] = 5; src_t.y[ 1 ] = 75; src_t.y[ 2 ] = -75;
	
	
	dest_i = SDL_CreateRGBSurface
		(
			src_i->flags,
			
			src_i->w, src_i->h,
			
			32,
			
			0, 0, 0, 0
		);
	if( !dest_i )
	{
		printf( "Failed to allocate destination surface 6: %s\n", SDL_GetError() );
	}
	data.dest = dest_i;
	
	
		/* This is where we loop over destination pixels. */
	i1 = r.x;
	i2 = r.y;
	while( i2 < r.h )
	{
		while( i1 < r.w )
		{
			( (Uint32*)( dest_i->pixels ) )[ i1 + dest_i->w * i2 ] =
				SDL_MapRGBA
				(
					dest_i->format,
					
					128, 0, 128, 0
				);
			
			
			++i1;
		}
		
		++i2;
		i1 = r.x;
	}
	
	printf( "TRI_REND() result 6: %i;\n", (int)( TRI_REND( &data, &dest_t, &src_t ) ) );
	
	
	if( SDL_SaveBMP( dest_i, "Result6.bmp" ) < 0 )
	{
		printf( "Failed to save destination surface 6: %s\n", SDL_GetError() );
	}
	
	SDL_FreeSurface( dest_i );
	dest_i = (SDL_Surface*)0;
	
	
	
	src_t.x[ 0 ] = 0; src_t.x[ 1 ] = 0; src_t.x[ 2 ] = 255;
		src_t.y[ 0 ] = 0; src_t.y[ 1 ] = 255; src_t.y[ 2 ] = 255;
	
	
	dest_i = SDL_LoadBMP( "Base1.bmp" );
	if( !dest_i )
	{
		printf( "Failed to open Base1.bmp as destination surface 7: %s\n", SDL_GetError() );
	}
	data.dest = dest_i;
	
	
	printf( "TRI_REND() result 7: %i;\n", (int)( TRI_REND( &data, &dest_t, &src_t ) ) );
	
	
	if( SDL_SaveBMP( dest_i, "Result7.bmp" ) < 0 )
	{
		printf( "Failed to save destination surface 7: %s\n", SDL_GetError() );
	}
	
	SDL_FreeSurface( dest_i );
	dest_i = (SDL_Surface*)0;
	
	
	
		/* Close. */
	SDL_FreeSurface( src_i );
	SDL_Quit();
	printf( "Done.\n" );
}
